#ifndef __ABAC_I_H__
#define __ABAC_I_H__

#include <credentials/certificates/x509.h>
#include <credentials/certificates/certificate.h>
#include <credentials/certificates/ac.h>
#include <credentials/keys/private_key.h>

#include "abac.h"

int abac_condition_set_aspect_ptr(abac_condition_t *ptr, abac_aspect_t *aptr);
int abac_condition_set_aspect_string(abac_condition_t *ptr, char *str);
int abac_condition_set_range_string(abac_condition_t *ptr);
int abac_condition_is_range(abac_condition_t *ptr);
abac_aspect_t *abac_condition_of_aspect(abac_condition_t *ptr);

void abac_aspect_dump(abac_aspect_t *ptr, char* offset);
abac_term_t *abac_aspect_object_term(abac_aspect_t *ptr);

void abac_condition_dump(abac_condition_t *ptr, char *offset);
abac_list_t *abac_condition_range_list(abac_condition_t *ptr);

void abac_term_dump(abac_term_t *ptr, char *offset);

abac_item_t *abac_item_new(int itype, char *val);
int abac_item_type(abac_item_t *);
char* abac_item_val(abac_item_t *);
void abac_param_dump(abac_param_list_t *ptr, char *offset);
abac_list_t *abac_param_list(abac_param_list_t *ptr);
char* abac_aspect_get_issuer_keytype(abac_aspect_t *ptr);
int abac_aspect_get_issuer_idtype(abac_aspect_t *ptr);

certificate_t *abac_attribute_issuer_cert(abac_attribute_t *ptr);
certificate_t *abac_attribute_cert(abac_attribute_t *ptr);
abac_attribute_t *abac_attribute_new(abac_id_t *issuer, certificate_t *cert, certificate_t *issuer_cert);
abac_id_t *abac_id_new(int idtype,char *keyid, char *cn, certificate_t *cert);
private_key_t *abac_id_privkey(abac_id_t *id);
certificate_t *abac_id_cert(abac_id_t *id);
abac_id_t *abac_id_keyid_new(char *keyid, char *cn, certificate_t *cert);

char *abac_termtype_string(int i);
char *abac_idtype_string(int);

extern int ABAC_IN_PROLOG;
extern int ABAC_IN_QUERY;
extern char *prologIt(char*);

#define PROLOG(BODY) {  \
    ABAC_IN_PROLOG++;      \
    { BODY }               \
    ABAC_IN_PROLOG--;      \
} 


#endif /* __ABAC_I_H__ */

